/*CREATE DATABASE labels_tower CHARACTER SET 'utf8';
USE labels_tower;*/

CREATE TABLE IF NOT EXISTS tutos (
	title VARCHAR(300),
	link VARCHAR(500) NOT NULL,
	date DEFAULT CURRENT_TIMESTAMP,
	prescriber VARCHAR(100),
	CONSTRAINT pk_tutos PRIMARY KEY (link)
);

CREATE TABLE IF NOT EXISTS labels (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	name VARCHAR(100) NOT NULL,
	father_id UNISGNED MEDIUM INT DEFAULT NULL
);

CREATE TABLE IF NOT EXISTS labels_languages (
	id_label INTEGER,
	country_code VARCHAR(3),
	name VARCHAR(100),
	CONSTRAINT pk_labels_languages PRIMARY KEY(id_label, country_code)
);

CREATE TABLE IF NOT EXISTS tutos_labels (
	link VARCHAR(200) NOT NULL,
	id_label UNSIGNED MEDIUM INT,
	CONSTRAINT pk_tutos_labels PRIMARY KEY(link)
	-- aucun des 2 ne sont uniques et moi j'utilise les 2 pour mes requêtes
);

CREATE TABLE IF NOT EXISTS alias (
	id_label UNSIGNED MEDIUM INT,
	name VARCHAR(100) NOT NULL,
	CONSTRAINT pk_alias PRIMARY KEY (name)
);

CREATE TABLE IF NOT EXISTS votes (
	link VARCHAR(200) NOT NULL,
	mark TINYINT,
	author_mail VARCHAR(100),
	CONSTRAINT pk_votes PRIMARY KEY (link, author_mail)
);

CREATE TABLE IF NOT EXISTS comments (
	link VARCHAR(200) NOT NULL,
	message VARCHAR(500),
	author_mail VARCHAR(100),
	date DATETIME DEFAULT CURRENT_TIMESTAMP,
	CONSTRAINT pk_comments PRIMARY KEY (message, author_mail, date)
);