import sqlite3
from update_labels import *
from add_tutos import *
from sql_request import *
from flask import Flask, request, render_template, render_template_string, jsonify

class CustomFlask(Flask):
    jinja_options = Flask.jinja_options.copy()
    jinja_options.update(dict(
        block_start_string='DD',
        block_end_string='DDE',
        variable_start_string='[[',
        variable_end_string=']]',
        comment_start_string='RF',
        comment_end_string='BG',
        ))

app = CustomFlask(__name__)
app.config['DEBUG'] = True

@app.route('/')
def home():
    return search_tuto()

@app.route('/get_datas/<string:name>', defaults={'id': None}, methods=['POST', 'GET'])
@app.route('/get_datas/<string:name>/<path:id>')
def get_datas(name, id):
    '''Return labels table or alias table for Ajax.
    '''
    if (name == 'labels'):
        return (jsonify(send_sql_request('SELECT * FROM labels')))
    if (name == 'all_labels'):
        return (jsonify(send_sql_request("SELECT id_label, labels_languages.name, father_id FROM labels_languages INNER JOIN labels ON labels.id = labels_languages.id_label  WHERE  labels_languages.country_code IN ('"+id+"',  'U')")))
    elif (name == 'main_labels'):
        return (jsonify(send_sql_request("SELECT * FROM (SELECT id_label, labels_languages.name, father_id FROM labels_languages INNER JOIN labels ON labels.id = labels_languages.id_label WHERE labels_languages.country_code IN ('"+id+"',  'U')) WHERE father_id IS NULL")))
    elif (name == 'alias'):
        return (jsonify(send_sql_request('SELECT * from alias')))
    elif (name == 'link'):
        return (jsonify(send_sql_request('SELECT link FROM tutos_labels WHERE id_label = '+id)))
    elif (name == 'labels_links'):
        return (jsonify(send_sql_request('SELECT link FROM tutos_labels WHERE id_label IN ('+id+')')))
    elif (name == 'labels_links_unselect'):
        return (jsonify(send_sql_request('SELECT link FROM tutos_labels WHERE id_label NOT IN ('+id+')')))
    elif (name == 'title_tuto'): #anciennement tuto
        return (jsonify(send_sql_request("SELECT title FROM tutos WHERE link = '"+id+"'")))
    elif (name == 'nb_labels'):
        return (jsonify(send_sql_request('SELECT COUNT (*) FROM labels')))
    elif (name == 'all_tutos'):
        return (jsonify(send_sql_request('SELECT * FROM tutos ORDER BY title')))
    elif (name == 'tutos'):
        return (jsonify(send_sql_request('SELECT * FROM tutos WHERE link IN ('+request.form['data']+') ORDER BY title')))
    elif (name == 'id_labels_tutos'):
        return (jsonify(send_sql_request('SELECT DISTINCT id_label FROM tutos_labels WHERE link IN ('+request.form['data']+')')))
    elif (name == 'labels_of_a_link'):
        return (jsonify(send_sql_request("SELECT id_label FROM tutos_labels WHERE link = '"+id+"'")))
    elif (name == 'tuto_family'):
        ''' Select all links that have the same group of labels.
        '''
        labels_tab = id.split(',')
        sql_request = ''
        n = 0
        nb_labels = len(labels_tab) 
        for id_lab in labels_tab:
            if (n == nb_labels - 1):
                sql_request += 'SELECT link FROM tutos_labels WHERE id_label IN ('+id_lab+')'
            else:
                sql_request += 'SELECT link FROM tutos_labels WHERE id_label IN ('+id_lab+') INTERSECT '
            n += 1
        return (jsonify(send_sql_request(sql_request)))
    return 'Error'

@app.route('/manage_labels', methods=['GET', 'POST'])
def manage_labels():
    '''For manage all labels and alias register in database.
    (Add new labels and alias actually)
    '''
    if request.method == 'GET':
        res = send_sql_request('SELECT * FROM labels')
        return render_template('manage_labels.html', labels=res)
    else:
        update_labels(request.form['alias_input'])
        return render_template('manage_labels.html', labels=request.form['alias_input'], success="Succès de l'envoie")

@app.route('/browse')
def search_tuto():
    return render_template('browse.html')

@app.route('/add_new_tuto', methods=['GET', 'POST'])
def add_new_tuto():
    '''Add new tuto in database.
    '''
    if request.method == 'GET':
        return render_template('add_new_tuto.html')
    else:
        res = add_tuto(request.form['title'], request.form['link'], request.form['labels'], request.form['prescriber'])
        return render_template('add_new_tuto.html', status=res)

@app.route('/test')
def test():
    cursor = connection.cursor()
    cursor.execute("SELECT * FROM labels")
    res = cursor.fetchall()
    connection.commit()
    print(res)
    return ("OK")